<Project xmlns="http://schemas.microsoft.com/developer/msbuild/2003" TreatAsLocalProperty="BuildProjectNamespace;TaskNamespace;TaskAssembly">
	<PropertyGroup>
		<BuildProjectNamespace>Cloudburst.BuildTools</BuildProjectNamespace>
		<TaskNamespace>$(BuildProjectNamespace).Tasks</TaskNamespace>
		<TaskAssembly Condition="'$(CloudburstTaskAssemblyLocation)' == ''">$(MSBuildThisFileDirectory)..\tasks\netstandard2.0\$(BuildProjectNamespace).dll</TaskAssembly>
		<TaskAssembly Condition="'$(CloudburstTaskAssemblyLocation)' != '' AND Exists('$(CloudburstTaskAssemblyLocation)')">$(CloudburstTaskAssemblyLocation)\$(BuildProjectNamespace).dll</TaskAssembly>
	</PropertyGroup>

	<UsingTask TaskName="$(TaskNamespace).IncrementalBuild" AssemblyFile="$(TaskAssembly)" />
	<UsingTask TaskName="$(TaskNamespace).VersionManager" AssemblyFile="$(TaskAssembly)" />
	<UsingTask TaskName="$(TaskNamespace).LocalNuget" AssemblyFile="$(TaskAssembly)" />
	<UsingTask TaskName="$(TaskNamespace).ProjectInformation" AssemblyFile="$(TaskAssembly)" />

	<Target Name="CloudburstProjectInformation" BeforeTargets="BeforeBuild">
		<PropertyGroup>
			<ProjectDetailsJson Condition="'$(ProjectDetailsJson)' == ''">ProjectDetails.json</ProjectDetailsJson>
			<ProjectIconFile Condition="'$(ProjectIconFile)' == ''">$(ProjectDir)..\icon.png</ProjectIconFile>
			<ProjectLicenseFile Condition="'$(ProjectLicenseFile)' == ''">$(ProjectDir)..\LICENSE</ProjectLicenseFile>
		</PropertyGroup>

		<ProjectInformation JsonFile="$(ProjectDetailsJson)">
			<Output TaskParameter="Details" ItemName="ProjectDetails" />
		</ProjectInformation>

		<Error Text="Project Namespace is not set." Condition="'%(ProjectDetails.Namespace)' == ''" />
		<Error Text="Project Title is not set." Condition="'%(ProjectDetails.Title)' == ''" />
		<Error Text="Project Description is not set." Condition="'%(ProjectDetails.Description)' == ''" />
		<Error Text="Project RepositoryName is not set." Condition="'%(ProjectDetails.RepositoryName)' == ''" />

		<Message Text="Project Namespace: %(ProjectDetails.Namespace)" />
		<Message Text="Project Title: %(ProjectDetails.Title)" />
		<Message Text="Project Description: %(ProjectDetails.Description)" />
		<Message Text="Project RepositoryName: %(ProjectDetails.RepositoryName)" />
		<Message Text="Project RepositoryUrl: %(ProjectDetails.RepositoryUrl)" />
		<Message Text="Project Directory: $(ProjectDir)" />
		<Message Text="Project Details Json: $(ProjectDetailsJson)" />
		<Message Text="Project Icon File: $(ProjectIconFile)" />
		<Message Text="Project License File: $(ProjectLicenseFile)" />

		<PropertyGroup>
			<Product>%(ProjectDetails.Title)</Product>
			<Title>%(ProjectDetails.Title)</Title>
			<Description>%(ProjectDetails.Description)</Description>
			<Copyright>%(ProjectDetails.ProjectCopyright)</Copyright>
			<Authors>%(ProjectDetails.ProjectAuthor)</Authors>
			<RepositoryUrl>%(ProjectDetails.RepositoryUrl)</RepositoryUrl>

			<PackageId>%(ProjectDetails.Namespace)</PackageId>
			<PackageProjectUrl>%(ProjectDetails.PackageProjectUrl)</PackageProjectUrl>
			<PackageIcon Condition="Exists('$(ProjectIconFile)')">%(ProjectDetails.ProjectIconFile)</PackageIcon>
			<PackageLicenseFile Condition="Exists('$(ProjectLicenseFile)')">%(ProjectDetails.ProjectLicenseFile)</PackageLicenseFile>
			<PackageLicenseExpression Condition="'$(PackageLicenseFile)' == ''">%(ProjectDetails.ProjectLicenseType)</PackageLicenseExpression>
		</PropertyGroup>

		<ItemGroup>
			<None Condition="Exists('$(ProjectIconFile)')" Include="$(ProjectIconFile)">
				<Pack>true</Pack>
				<PackagePath />
			</None>
			<None Condition="Exists('$(ProjectLicenseFile)')" Include="$(ProjectLicenseFile)">
				<Pack>true</Pack>
				<PackagePath />
			</None>
		</ItemGroup>
	</Target>

	<!--
	Options: True or False

	Enabled by Default
	<CloudburstManageVersion>True</CloudburstManageVersion>
	-->
	<Target Name="CloudburstManageProjectVersion" BeforeTargets="BeforeBuild;Restore" Condition="'$(CloudburstManageVersion)' != 'False'">
		<PropertyGroup>
			<VersionFilePath Condition="'$(VersionFilePath)' == ''">$(ProjectDir)..\</VersionFilePath>
		</PropertyGroup>

		<VersionManager
				Configuration="$(Configuration)"
				VersionFilePath="$(VersionFilePath)"
				DontIncrement="$(VersionDontIncrement)">
			<Output TaskParameter="Version" PropertyName="Version" />
			<Output TaskParameter="Major" PropertyName="Major" />
			<Output TaskParameter="Minor" PropertyName="Minor" />
			<Output TaskParameter="Patch" PropertyName="Patch" />
			<Output TaskParameter="Build" PropertyName="Build" />
		</VersionManager>

		<PropertyGroup>
			<Version>$(Version)</Version>
			<FileVersion>$(Version)</FileVersion>
			<ApplicationVersion>$(Version)</ApplicationVersion>
			<AssemblyVersion>$(Version)</AssemblyVersion>
			<InformationalVersion>$(Version)</InformationalVersion>
			<ProductVersion>$(Version)</ProductVersion>

			<PackageVersion Condition="'$(GeneratePackageOnBuild)' == 'true' AND '$(Configuration)' == 'Release'">$(Major).$(Minor).$(Patch)</PackageVersion>
			<PackageVersion Condition="'$(GeneratePackageOnBuild)' == 'true' AND '$(Configuration)' == 'Debug'">$(Major).$(Minor).$(Patch)-Build.$(Build)</PackageVersion>
		</PropertyGroup>
	</Target>

	<!--
	Options: True or False

	Enabled by Default
	<CloudburstCopyPackageToLocalNuget>True</CloudburstCopyPackageToLocalNuget>
	-->
	<Target Name="CopyCloudburstPackageToLocalNuget" AfterTargets="Pack" Condition="'$(CloudburstCopyPackageToLocalNuget)' != 'False'">
		<PropertyGroup>
			<LocalNugetPackagesDirName Condition="'$(LocalNugetPackagesDirName)' == ''">$(ProjectDir)..\LocalNugetPackages</LocalNugetPackagesDirName>
		</PropertyGroup>

		<LocalNuget DirName="$(LocalNugetPackagesDirName)" CreateMissing="True">
			<Output TaskParameter="LocalNugetPath" PropertyName="LocalNugetPath" />
		</LocalNuget>

		<Copy SourceFiles="$(OutputPath)..\$(PackageId).$(PackageVersion).nupkg" DestinationFolder="$(LocalNugetPath)" />
		<Message Text="Copied $(PackageId).$(PackageVersion).nupkg to $(LocalNugetPath)" />
	</Target>

</Project>
